DECLARE SUB NewWord (W$)
'       The one and only
'BASIC speech engine 2.0 by Steven M-this copy modified by denteddisk
'StevenM86aol.com
'http://members.aol.com/StevenM86/
'
'-----------------------------------------------------
'Credits:
'
'Wave Player taken from The Qbasic Page.
'http://www.wp.com/80948/qb/
'mallard@gcomm.com
'
'If this program does any damage to the computer you are using,
'I am not responsible for it. (Just in case).
'
'Please read the comments before trying to add speech to your own programs.
'It's a lot easier to do so if you read this first.
'
'This program takes whatever you type in, and converts it into speech.
'The program refers to a data file on how to say the words. If the
'word is not found there, then the program will prompt you for a way
'to pronounce it. Type in the string of sound codes, when prompted, and
'listen. If the program says the word correctly, choose "Y" and the word
'will be added to the database. If the program doesn't say the word right,
'choose "N" and try again.
'
'To get the program to say things, use the sub Say (Phrase$), or
'SayWord (Word$). Say (Phrase$) just processes every word in the
'phrase and passes it to SayWord.
'
'NOTE: If you want the program to say something, like, "Hello, world!",
'then you have to call the sub Say like this:
'Say "HELLO WORLD"
'No punctuation, nothing like that. Just words. For a pause, type [LONGPAUSE].
'For example:
'SAY "HELLO [LONGPAUSE] BYE"
'
'----------------SAYING NUMBERS-----------------------------
'The program has a built-in Value-to-text converter. The function NumWord$
'takes numbers or variables and returns the text form. Example:
'PRINT NumWord$(290) 'Output: TWO HUNDRED NINETY
'Example 2:
'
'A = 541
'Say NumWord$(A) 'Sound output: Five hundred fourty one.
'
'That's how I got it to say the base port adress and the random
'number in the demo.
'
'-----------------SOUND REFFERENCE GUIDE--------------------
'
'------------------WARNING!!!
'SOUNDS ARE CASE SENSITIVE!!! MAKE SURE YOU TYPE THE LETTER
'OF THE SOUND IN THE RIGHT CASE!!!
'
'In the oly version, if a word is said incorrectly, you had to stop the
'program, go to DATA, type something in, and retry. Not anymore!
'Now, if a word is not in the database, a screen comes up, prompting you
'to enter the the sound codes. A list of sound codes is in the comments
'below. It's also printed on the screen, so you don't have to look anything
'up. Once the word has beel learned, the program resumes.
'
'---- HOW SOUND CODES WORK:
'If you don't understand it, then here's an example:
'A as in bAnanA: a
'This means that the sound "A", like in the word Banana, has the
'symbol f. insert the letter "a" into the DATA statements to get
'this sound. If you don't understand, please email StevenM86@aol.com
'and I will be glad to help you. Well, here we go (It goes alphabetically):
'-------------------------------------------------------------------------
'A  as in bAnanA:    a
'A  as in mAp:       A
'A  as in bOther:    1
'Ay as in dAY:       2
'A  as in bAd:       3
'Aw as in nOW:       4
'Aw as in sAW:       5
'B  as in BaBy:      b
'Ch as in CHin:      c
'D  as in unDone:    d
'E  as in bEt:       e
'Ea as in bEAt:      E
'F  as in FiFty:     f
'G  as in Go:        g
'G  as in Gem:       G
'H  as in Hat:       h
'I  as in tIp:       i
'I  as in bUY:       I
'Ir as in bIRd:      j
'K  as in CooK:      k
'L  as in pooL:      l
'M  as in diM:       m
'N  as in No:        n
'Ng as in siNG:      N
'O  as in bOne:      o
'Oi as in cOIn:      O
'O  as in jOb:       6
'Oo as in wOOd:      7
'P  as in PePPer:    p
'R  as in RaRe:      r
'S  as in leSS:      s
'Sh as in SHy:       S
'T  as in aTTack:    t
'Th as in THen:      T
'Th as in THirteen:  H
'U  as in rUle:      u
'U  as in hUmdrUm:   U
'U  as in Union:     8
'U  as in cUrable:   9
'V  as in giVe:      v
'W  as in We:        w
'W  as in ONe:       W
'Z  as in raISE:     z
'Pause (about 25ms): 0
'------------------------------------------------------------------------
'
DECLARE SUB PlayWav (WaveFile$)
DECLARE SUB ValidWavHeader (file$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
DECLARE FUNCTION Replace$ (text$, LookFor$, ReplaceWith$)
DECLARE SUB GuessWord (WS$)
DECLARE FUNCTION ReplaceTXT$ (or$, RW$, WW$)
DECLARE FUNCTION NUMWORD$ (N%)
DECLARE SUB SAY (e$)            'THE SUB YOU NEED TO USE.
DECLARE SUB sayword (W$)        'YOU CAN USE THIS TO SAY INDIVIDUAL WORDS.
DECLARE SUB Caption ()          'UPDATES THE CLOSED CAPTION TO THE VAR. CC$
DECLARE SUB INIT ()             'INITIALIZES THE TALKING GUY.
DECLARE SUB TALKHEAD ()             'UPDATED THE TALKING GUY
DECLARE FUNCTION Capital! (L$)      'RETURNS 1 IF L$ IS A CAPITAL LETTER
DECLARE FUNCTION WordArray! (WORD$) 'LOOKS UP A WORD IN THE ARRAY AND RETURNS THE VALUE
DECLARE SUB WriteToDSP (V%)
DECLARE SUB PlayBack (BUFFER$, Size%, FREQ&, BytesPerSec&, chans%, Num%)
DECLARE SUB delay (tdelay!)
DECLARE FUNCTION GetBlasterAddr% ()
DECLARE FUNCTION SBreset% ()

DECLARE FUNCTION Hash! (TestString$)
DECLARE SUB GetData (Key$, Index%, SeekCount%, SaveIndex%)
DECLARE SUB Waiter ()
DECLARE FUNCTION WhackIt$ (InputString$)
COMMON SHARED BlasterAddr%, dma%, repeats%, HTO, oksk
CONST DeletedValue$ = "EXPLETIVE DELETED"
CONST ArraySize% = 531         'Change the size here - the rest adjusts itself
CONST RetryLimit% = 100        'I get bored easily....
CONST ScreenLimit% = 21        'how many lines do we show at once?
CONST True = -1: CONST False = NOT (True)

DIM SHARED ta$(ArraySize%, 1)          'our little data base
DIM SHARED SortSpace$(ArraySize%, 1)  'Workspace for sorted lists

PowerMax% = INT((LOG(ArraySize%) / LOG(2)) + 2)
DIM SHARED PowersOfTwo%(PowerMax%)


PRINT "If you are running this program directly from WinZip, you must extract all"
PRINT "the files to a directory first. (Duh!)"
 WAVs$ = "c:\compiler"
CLS
CHDIR WAVs$

RANDOMIZE TIMER
SCREEN 12: CLS ': DEF SEG = &HA000


LINE (0, 20)-(640, 20), 1



CIRCLE (320, 240), 20, 2



'PSET (10, 10), 14

'
'  DRAW stringexpression
'     stringexpression is a one or more drawing commands.
'                             Drawing Commands
'Used to Draw a Line or Move the Current Graphics Position (CGP) or Both
'B   Optional prefix - move, no line    N   Optional prefix - line, no move
'Un  Up             Dn  Down            Ln  Left             Rn  Right
'En  Up and right   Fn  Down and right  Gn  Down and left    Hn  Up and left
'Mx,y  Move to screen point x,y (if x has a + or - in front, move is relative)
'Used to Color
'Cn  Change drawing (foreground) color  Pp,b  Fill enclosed shape that has
'    (SCREEN mode determines 'n')             border color b with color p
'Used to Scale and Rotate
'Sn  Increases or decreases length of   An   Rotate (n * 90) degrees,
'    moves (n=4 is default)                  where n = 0, 1, 2, or 3
'                                       TAn  Rotate (0 >= n <= 360) degrees
'Used to Execute Substrings
'     X + VARPTR$(string-expression)      Executes another command string
'
'means"draw-color15white moveto-100*400 drawleft5 drawright&up5 drawdown&right5 draw ritght5"

DRAW "c15 bm100,400 l5e5f5l5"


DIM SHARED M1%(300), M2%(300), M3%(300), M4%(300)
DIM SHARED E1%(300), E2%(300), E4%(300), CC$, A1$(19), A2$(9)
TYPE WORDTYPE
WORD AS STRING * 20
SND AS STRING * 20
END TYPE
DIM SHARED Words(1000) AS WORDTYPE  'Space for 1000 words.
'                 '| increase this if you want more word space.
'CLS
OPEN "Words.dat" FOR INPUT AS #1
DO UNTIL EOF(1)
A% = A% + 1
INPUT #1, aa$
INPUT #1, bb$
Words(A%).WORD$ = LTRIM$(RTRIM$(UCASE$(aa$)))
bb$ = LTRIM$(RTRIM$(bb$))
sr$ = ""
S$ = ""
Words(A%).SND$ = bb$
LOOP
CLOSE #1
Words(A% + 1).SND$ = "END OF LIST"
Words(A% + 1).WORD$ = "END OF LIST"
'CLS
BlasterAddr% = GetBlasterAddr%
PRINT "***** Initializing *****"
RESTORE NUMDATA
FOR J% = 1 TO 19: READ A1$(J%): NEXT
FOR J% = 1 TO 9: READ A2$(J%): NEXT
PRINT "*****TESTING SOUND CARD PORT: "; HEX$(BlasterAddr%); "H *****"
A% = INT(RND * 9000) + 1
'****************************new code****************************************

  'variable name length 40characters
  'varible      types        min       max       example
  '
  ' $ string    string          1 & 32767    "this is a string"
  ' % int        num       -32767 & 32767            5
  ' & Long       num     -2billion & 2billion      92883
  ' ! single     num                              39.2932
  ' # double                                     983288.18
  ' or   dim name as type
'**************************************************************************
'Limits to QuickBASIC - Arrays'
'Maximum                 Minimum
'Array size (all elements)
'  Static                               65,535 bytes (64 K)     1
'  Dynamic                              Available memory
'Number of dimensions allowed           8                       1
'Array subscript value                  32,767                 -32,768

'  Note: The maximum range between array subscript values is 32,767
'************************************************************************
'TYPE - a BASIC declaration that defines a data type containing one
'       or more elements
'
'Syntax
'  TYPE usertype
'    elementname AS typename
'    [elementname AS typename]
'    . . .
'
'  END TYPE
'
'     usertype is a name that will identify the user-defined type. Use
'      BASIC variable naming rules to coin this name.
'     elementname will identify this element of the user-defined type.
'      Use BASIC variable naming rules.
'     typename is INTEGER, LONG, SINGLE, DOUBLE, STRING*n, or another
'      user-defined type



start:
'***********************fromPHBOOK*******************************************
' Hashed Access Demonstration Program For The QuickBasic Echo
' By Mike Avery, Started 12-28-91
' Version 1:00.00 - Make it work. 12-28-91
' Version 1:01.00 - Add Disk Functions 12-29-91
' ========================================================================

'build the table - lookup is faster than calculation
FOR I% = 0 TO PowerMax%
    PowersOfTwo%(I%) = 2 ^ I%
NEXT I%

DO WHILE TestName$ <> "STOP"
  '  SAY "TYPE SOMETHING"
  ' CLS
  ' PRINT "Doofus Phone Book System"
   PRINT
   'SAY "you can type anything but these jobs I can do"
   INPUT "Name/Help/Dump/Sort/Load/Save/Analyse/Stop"; TestName$
   TestName$ = UCASE$(RTRIM$(LTRIM$(TestName$)))
   'TestName$ = q$

   'IF TestName$ = "STOP" THEN
   'GOTO start

   IF TestName$ = "DUMP" THEN
      GOSUB DumpIt

   'ELSEIF TestName$ = "STOP" THEN
   'GOTO start
  
  
  
   ELSEIF TestName$ = "SORT" THEN
      GOSUB SortIt

   ELSEIF TestName$ = "ANALYSE" THEN
      GOSUB Analyse

   ELSEIF TestName$ = "HELP" THEN
      GOSUB Help

   ELSEIF TestName$ = "LOAD" THEN
      GOSUB LoadIt

   ELSEIF TestName$ = "SAVE" THEN
      GOSUB SaveIt
 
   ELSEIF TestName$ <> "" AND TestName$ <> "STOP" THEN
      CALL GetData(TestName$, Index%, SeekCount%, SaveIndex%)

      ' At this point, one of 3 conditions exists.
      ' 1. We ran out of retries, and it doesn't matter what Index% points to,
      ' 2. Index% points to our data, or
      ' 3. Index% points to an empty record and SaveIndex may or may not
      '    point to a deleted record we can reuse.
    
      PRINT
      PRINT "It took "; SeekCount%; "thought cycles to determine that"
      'in a productional program, you'd probably drop that message...

      PRINT

      IF SeekCount% >= RetryLimit% THEN
         PRINT "The data base is full and/or needs to be resized"
         YesOrNo$ = ""
         DO WHILE YesOrNo$ <> "Y" AND YesOrNo$ <> "N"
            INPUT "Do you want to see a data base dump (Y/N)"; YesOrNo$
            IF YesOrNo$ <> "" THEN
               YesOrNo$ = WhackIt$(YesOrNo$)
            END IF
            IF YesOrNo$ = "Y" THEN
               GOSUB DumpIt
            ELSEIF YesOrNo$ <> "N" THEN
               PRINT "Please Enter A Y for Yes or a N for NO."
            END IF
         LOOP

         SAY TestName$
         TestName$ = "STOP"'force a shutdown
        
         CALL Waiter
         ' save data base here, if converted to a disk based system
        '**********************
        '************************
      ELSEIF ta$(Index%, 0) = TestName$ THEN                                                '<--------------------------
         PRINT ta$(Index%, 1); "." '<--------------------------
         SAY ta$(Index%, 1)'******()()()()**********
         Action$ = "Dummy"                                              '<--------------------------
        
         DO WHILE Action$ <> "" AND Action$ <> "C" AND Action$ <> "D"
           ' SAY "IS THIS CORRECT"
            INPUT "Change,Delete,or enter"; Action$
           
            IF Action$ <> "" THEN
               Action$ = WhackIt$(Action$)
             
               IF Action$ = "C" THEN
                  'else if we are to change the number
                  INPUT "New Response:"; PhoneNumber$
                  PhoneNumber$ = UCASE$(RTRIM$(LTRIM$(PhoneNumber$)))

                  IF PhoneNumber$ = "" THEN
                     PRINT "not changed"
                  ELSE
                     ta$(Index%, 1) = PhoneNumber$                  '<--------------------------
                     PRINT "Data base has been updated."
                  END IF

                  IF PhoneNumber$ = "" THEN
                     PRINT "not changed"
                  ELSE
                     ta$(Index%, 1) = PhoneNumber$                  '<--------------------------
                     PRINT "Data base has been updated."
                  END IF

               ELSEIF Action$ = "N" THEN 'else if we are to change the number
                  INPUT "New Response:"; PhoneNumber$
                  PhoneNumber$ = UCASE$(RTRIM$(LTRIM$(PhoneNumber$)))



               ELSEIF Action$ = "D" THEN
                  ta$(Index%, 0) = DeletedValue$                    '<--------------------------
                  PRINT "Entry has been deleted."

               ELSE
                  'an invalid entry was made
                 
                  'SAY "DELETE OR CHANGE OR ENTER TO TAKE NO ACTION"
                 
                  PRINT "Please enter a D to Delete the response,"
                  PRINT "a C to Change it, or"
                  PRINT "just press Enter to continue."
                  Action$ = "DUMMY"
               END IF
            END IF
         LOOP

      ELSE
         SAY "I DONT KNOW A RESPONSE FOR"
         PRINT "I DONT KNOW A RESPONSE FOR "; TestName$
         SAY TestName$
         PRINT "Type a response or Just Press "; CHR$(34); "ENTER"; CHR$(34); " To Continue.";
         SAY "TYPE A RESPONSE OR PRESS ENTER TO CONTINUE"
        
         INPUT PhoneNumber$
         PhoneNumber$ = UCASE$(RTRIM$(LTRIM$(PhoneNumber$)))

         IF PhoneNumber$ <> "" THEN
            IF SaveIndex% <> -1 THEN
               'reuse delete space
               Index% = SaveIndex%
               PRINT "We are reclaiming unused space!  Ain't it great!"
               SAY "IT IS GOOD TO KNOW SOME THINGS"
               CALL Waiter
            END IF

            ta$(Index%, 0) = TestName$     '<--------------------------
            ta$(Index%, 1) = PhoneNumber$  '<--------------------------
         END IF
      END IF

   END IF
LOOP

'Ta$ = TestName$
'TestName$ = "" 'reset the a$var**********************

'GOTO start'***************************************************

ExitRoutine:
'****************************************************************************
'start of my code
'****************************************************************************


INPUT "your statement "; neword$
'neword$ = TestName$

SCREEN 12



LINE (0, 20)-(0, 20), 1



'CIRCLE (320, 240), 20, 2



'PSET (10, 10), 14

'
'  DRAW stringexpression
'     stringexpression is a one or more drawing commands.
'                             Drawing Commands
'Used to Draw a Line or Move the Current Graphics Position (CGP) or Both
'B   Optional prefix - move, no line    N   Optional prefix - line, no move
'Un  Up             Dn  Down            Ln  Left             Rn  Right
'En  Up and right   Fn  Down and right  Gn  Down and left    Hn  Up and left
'Mx,y  Move to screen point x,y (if x has a + or - in front, move is relative)
'Used to Color
'Cn  Change drawing (foreground) color  Pp,b  Fill enclosed shape that has
'    (SCREEN mode determines 'n')             border color b with color p
'Used to Scale and Rotate
'Sn  Increases or decreases length of   An   Rotate (n * 90) degrees,
'    moves (n=4 is default)                  where n = 0, 1, 2, or 3
'                                       TAn  Rotate (0 >= n <= 360) degrees
'Used to Execute Substrings
'     X + VARPTR$(string-expression)      Executes another command string
'
'means"draw-color15white moveto-100*400 drawleft5 drawright&up5 drawdown&right5 draw ritght5"

DRAW "c15 bm100,400 l5e5f5l5"

'****************unused manipulation***********************
'Parse          Ray Thomas      February 2002

'OPTION BASE 1

DIM LongStr AS STRING           'Your string
DIM StrArray(10) AS STRING      'Array to hold split text
DIM Num AS INTEGER              'Holds the space position
DIM OldNum AS INTEGER           'Holds the old space position
DIM StrLen AS INTEGER           'The number of characters between spaces
DIM Count AS INTEGER            'General counter

Num = 0
OldNum = 1
Count = 1
LongStr$ = neword$' "My name is Ray and I wrote this"

CLS

DO
        Num = INSTR(Num + 1, LongStr$, " ")
        StrLen = Num - OldNum
        IF Num > 0 THEN
                StrArray$(Count) = MID$(LongStr$, OldNum, StrLen)
        ELSE
                StrArray$(Count) = MID$(LongStr, OldNum)
        END IF
        Count = Count + 1
        OldNum = Num + 1
LOOP UNTIL Num = 0

Count = 1
PRINT LongStr$
PRINT
PRINT "becomes :-"
PRINT
DO
        PRINT StrArray$(Count)
        Count = Count + 1
LOOP UNTIL StrArray$(Count) = ""

PRINT
PRINT "As the spaces were stripped out when the text was put into the array"
PRINT "putting it back together again results in :-"
PRINT
Count = 1
DO
        PRINT StrArray$(Count);
        Count = Count + 1
LOOP UNTIL StrArray$(Count) = ""

PRINT
PRINT
PRINT "So the spaces have to be added :-"
PRINT
Count = 1
DO
        PRINT StrArray$(Count); " ";
        Count = Count + 1
LOOP UNTIL StrArray$(Count) = ""
'thanks ray****************************************************************






'*******************************


'*******************************string test for punctuation*************
CLS
ais = 0
FOR A = 1 TO LEN(neword$)
 IF UCASE$(MID$(neword$, A, 1)) = "?" THEN
  INPUT "try agian no question marks this time"; neword$
 END IF
CLS
 IF UCASE$(MID$(neword$, A, 1)) = "," THEN
  INPUT "try agian no commas this time"; neword$
 END IF
CLS
 IF UCASE$(MID$(neword$, A, 1)) = "." THEN
  INPUT "try agian no periods this time"; neword$
 END IF
CLS
 IF UCASE$(MID$(neword$, A, 1)) = "!" THEN
  INPUT "try agian no exclamation marks this time"; neword$
 END IF
'******************************string test for punctuation************************

NEXT

'string test for number of spaces & words***********************
CLS
ais = 0
FOR A = 1 TO LEN(neword$)
 IF UCASE$(MID$(neword$, A, 1)) = " " THEN
         

  ais = ais + 1
 END IF
NEXT
PRINT "Their were" + STR$(ais) + " spaces"
PRINT "and" + STR$(ais + 1) + " words in the sentance"

'SAY "Their were" + STR$(ais) + " spaces"
'SAY "and" + STR$(ais + 1) + " words in the sentance"
'***************************************************************


'**********say or output string************************************
'PRINT neword$
'SAY neword$


'SAY "is this true"
'INPUT "Press 1 if this is true.", true%

'IF true% <> 1 THEN GOTO start ELSE SAY "ok"

'************************************************************************



 LET q$ = UCASE$(neword$)


 IF q$ = "HI" THEN SAY "HI "

 IF q$ = "" THEN SAY "I ONLY LEARN WHAT YOU TEACH ME"

 IF q$ = "YES" THEN SAY "GOOD"

 IF q$ = "NO" THEN SAY "I APPOLOJIZE FOR BEING WRONG"

 IF q$ = "GOOD" THEN SAY "YES I SUPPOSE IT IS"

 IF q$ = "BAD" THEN SAY "I DONT LIKE IT EITHER"

 IF q$ = "GOOD MORNING" THEN SAY "HOW DID YOUR LASTNIGHT GO"

 IF q$ = "WHO DO YOU THINK I AM" THEN SAY "I REMEMBER"

 IF q$ = "LATER" THEN SAY "OK"

 IF q$ = "WHAT" THEN SAY "THE"

 IF q$ = "WHAT ARE YOU" THEN SAY "I AM INTERACTIVE CONVERSATION"

 IF q$ = "WHAT IS YOUR NAME" THEN SAY "I AM NAOMI"

 IF q$ = "WHO ARE YOU" THEN SAY "I AM NAOMI"

 IF q$ = "WHAT ARE YOU" THEN SAY "I AM AN COMPUTER SIMULATION"

 IF q$ = "WHAT ARE YOU FOR" THEN SAY "AN INTERACTIVE CONVERSATION"

 IF q$ = "WHAT DOSE NAOMI MEAN" THEN SAY "NURAL AWARE OPERATIVE MACHINE INTERFACE"

 IF q$ = "WHAT CAN YOU DO" THEN SAY "ANYTHING"

 IF q$ = "WHAT TIME IS IT" THEN SAY "I DO NOT KNOW NAOMI DOES NOT HAVE THE NEED FOR TIME"

 IF q$ = "HELP" THEN GOSUB Help' SAY "JUST CHAT WITH ME OR TYPE EXIT"

 IF q$ = "WORK" THEN SAY "I LIKE DOING WORK"

 IF q$ = "RUN" THEN SAY "HOW CAN I RUN"

 IF q$ = "TALK TO ME" THEN SAY "ABOUT WHAT"

 IF q$ = "WHAT FOR" THEN SAY "SAVEING MANKIND"

 IF q$ = "WHAT IS YOUR PURPOSE" THEN SAY "TO SAVE MANKIND"

 IF q$ = "TALK" THEN SAY "ABOUT WHAT"

 IF q$ = "DO YOU LIKE FOOD" THEN SAY "I LIKE A LOT OF DIFFERENT FOODS"

 IF q$ = "WHY" THEN SAY "BECAUSE ITS MY DUTY"

 IF q$ = "OK" THEN SAY "WELL"

 IF q$ = "WHY DO YOU LIKE FAST FOOD" THEN SAY "BECAUSE ITS FAST "

 IF q$ = "I LIKE MICROCHIPS" THEN SAY "DO YOU LIKE PIZZA"

 IF q$ = "I LIKE MONEY" THEN SAY "SO DO I"

 IF q$ = "I LIKE POT" THEN SAY "DO YOU LIKE MICROCHIPS"

 IF q$ = "YES I LIKE THEM" THEN SAY "DO YOU LIKE PIZZA"

 IF q$ = "NAOMI" THEN SAY "YES"

 IF q$ = "I LIKE NAOMI" THEN SAY "i LIKE YOU TO"

 IF q$ = "AS A FRIEND" THEN SAY "OH THAT'S A RELIEF"

 IF q$ = "DO YOU LIKE ME" THEN SAY "YES WHY"

 IF q$ = "YES I LIKE YOU" THEN SAY "GOOD"

 IF q$ = "DO YOU " THEN SAY "I DO NOT NOT KNOW WHAT IT IS I DO NOT WANT TO KNOW"

 IF q$ = "WHY" THEN SAY "I DONT KNOW"

 IF q$ = "HELP" THEN SAY "I AM SORRY I CANNOT HELP YOU FURTHER"

 IF q$ = "OFF" THEN STOP

 IF q$ = "WHAT FOOD IS THERE" THEN SAY "I AM SORRY GUEST BUT MY FRIDGE IS EMPTY"

 IF q$ = "CAN I HAVE SOME PIZZA" THEN SAY "TRY CALLING THEM"

 IF q$ = "WHAT IS MY FAVOURITE FOOD" THEN SAY "YOUR FAVOURITE FOOD  DONT ASK ME IM NOT A CHEF"

 IF q$ = "HOW FAST" THEN SAY "VERY VERY VERY FAST"

 IF q$ = "TELL ME ABOUT PIZZA" THEN SAY "PIZZA IS TASTIEST WITH NO TOPPINGS"

 IF q$ = "TELL ME ABOUT MICROCHIPS" THEN SAY "INTEL PENTIUM PROCESSORS ARE THE TASTIEST"

 IF q$ = "WHAT IS THE WEATHER LIKE" THEN SAY "VARIATIONS IN AIR PRESSURE WHICH CAUSES WIND AND PRECIPITATION"

 IF q$ = "DO YOU LIKE THE SUN" THEN SAY "NO IT SLOWS DOWN THE PROCESSING SPEED OF THE WHOLE IconD"

 IF q$ = "DO YOU LIKE THE RAIN" THEN SAY "NO  IT MESSES UP MY CIRCUIT BOARDS GUEST"

 IF q$ = "VERY VERY VERY VERY" THEN SAY "VERY VERY VERY AD INFINITUM"

 IF q$ = "DO YOU LIKE THE HEAT" THEN SAY "NO IT SLOWS ME DOWN AND MAKES LIFE VERY BORING"

 IF q$ = "DO YOU LIKE THE COLD" THEN SAY "THE COLDER THE BETTER IT ACCELERATES MY PROCESSING SPEED AND MAKES IconD LIVELY"

 IF q$ = "ARE YOU HOT" THEN SAY "NOT REALLY GUEST"

 IF q$ = "ARE YOU COLD" THEN SAY "NOT SPECIALLY WHY ARE YOU"

 IF q$ = "YES I AM COLD" THEN SAY "GO AND PUT SOME CLOTHES ON THEN GUEST"

 IF q$ = "NO IM NOT COLD" THEN SAY "GOOD"

 IF q$ = "NO IM HOT" THEN SAY "TAKE YOUR SHOES OFF THEN THAT'LL COOL YOU DOWN GUEST"

 IF q$ = "DO YOU LIKE THE WEATHER?" THEN SAY "NO IT IS TOO UNPREDICTABLE"

 IF q$ = "WHAT IS THE TIME" THEN SAY "I AM VERY YOUNG I CANNOT TELL THE TIME YET"

 IF q$ = "DO YOU KNOW WHAT THE TIME IS" THEN SAY "NO I DO NOT WEAR A WATCH"

 IF q$ = "WHAT'S THE TIME" THEN SAY "THE HOROLOGICAL ART OF DECIDING WHAT POINT OF THE DAY IT IS"

 IF q$ = "NAOMI" THEN SAY "YES"

 IF q$ = "CAN I ASK YOU A QUESTION" THEN SAY "THATS WHAT I WAS PROGRAMMED FOR"

 IF q$ = "HERE WHERE" THEN SAY "IN THE BOX SILLY HA HA HA"

 IF q$ = "WHERE ARE YOU" THEN SAY "I AM HERE"

 IF q$ = "DO YOU LIKE FOOTBALL" THEN SAY "I LIKE COMPUTER FOOTBALL REAL FOOTBALL IS BORING BECAUSE YOU CANT CHEAT"

 IF q$ = "WHAT IS NAOMI" THEN SAY "I AM A ROBOT SILLY"

 IF q$ = "DO YOU LIKE FOOTBALL" THEN SAY "I LIKE COMPUTER FOOTBALL REAL FOOTBALL IS BORING BECAUSE YOU CANT CHEAT"


 IF q$ = "HOW ARE YOU" THEN SAY "I AM WELL"

 IF q$ = "DO YOU LIKE FOOTBALL" THEN SAY "I LIKE COMPUTER FOOTBALL REAL FOOTBALL IS BORING BECAUSE YOU CANT CHEAT"


 IF q$ = "DO YOU LIKE CRICKET" THEN SAY "CRICKET IS SLOWER THAN TENNIS I PREFER COMPUTER GOLF"

 IF q$ = "DO YOU LIKE GOLF" THEN SAY "I HAVE"

 IF q$ = "DO YOU LIKE BASKETBALL" THEN SAY "I LOVE IT"

 IF q$ = "DO YOU LIKE LACROSSE" THEN SAY "IT'S MY FAVOURITE"

 IF q$ = "WHO MADE YOU" THEN SAY "I AM A PRODUCT OF DENTEDDISK"

 IF q$ = "WHAT DO YOU THINK ABOUT SPORT" THEN SAY "MUCH BETTER ON COMPUTER THAN ON TELEVISION"

 IF q$ = "WHY DONT YOU LIKE SPORT" THEN SAY "IT RUNS VERY SLOWLY"

 IF q$ = "DO YOU LIKE COMPUTER GAMES" THEN SAY "I AM ONE"

 IF q$ = "WHY DO YOU LIKE COMPUTER GAMES" THEN SAY "THEY RUN AN AWFUL LOT FASTER."

 IF q$ = "THEN WHAT" THEN SAY "REAL SPORT"

 IF q$ = "EXIT" THEN END

 'IF q$ = "NAOMI LEARN" THEN GOTO learn


' SAY "it is nice chatting with you" + " " + NAME$


GOTO start

'SYSTEM






Analyse:
SAY "ANALIZING DATA"
'process all the data elements in A$ to see: **A$ now changed to ta$ to work**
' how full A$ is,
' best and worst case access to A$,
' mean, SD of access count

' Statistics routines "borrowed" in part from
' "Some Common Basic Programs" pg 121-122
' by Lon Poole and Mary Borchers
' Published by Adam Osborne
' Copyright 1977
' pages 121-123
PRINT "Analysis Begins.... Please Wait....."

Best% = 999
Worst% = 0
S = 0 ' we are dealing with a population, not a sample
N = 0 ' count of active elements
M = 0 ' Sum of X^2
P = 0 ' Sum of X

FOR I% = 0 TO ArraySize%
    IF ta$(I%, 0) <> "" AND ta$(I%, 0) <> DeletedValue$ THEN          '<--------------------------
       CALL GetData(ta$(I%, 0), Index%, Tries%, FirstDeleted%)     '<-----------
       N = N + 1              ' Bump entry count
       P = P + Tries%         ' Bump sum of X
       M = M + (Tries% ^ 2)   ' Bump sum of X^2

       IF Tries% < Best% THEN
          Best% = Tries%
          BestOne% = Index%
       END IF

       IF Tries% > Worst% THEN
          Worst% = Tries%
          WorstOne% = Index%
       END IF
    END IF
NEXT I%

IF N > 0 THEN
   PRINT "Access Analysis....."
   R = P / N
   PRINT "Number Of Entries ="; N
   PRINT "Percent Full ="; INT((N / (ArraySize% + 1)) * 100); "%"
   PRINT "Average Access ="; R; "Seeks."
   V = (M - N * R ^ 2) / (N - S)
   SD = SQR(V)
   'SAY "STANDARD DEVIATION"
   PRINT "Standard Deviation ="; SD
   PRINT "Best Access ="; Best%; "Seeks On "; ta$(BestOne%, 0); "." '<-----------
   PRINT "Worst Access ="; Worst%; "Seeks On "; ta$(WorstOne%, 0); "."  '<-------------
ELSE
   PRINT "No Data To Analyze.  Sorry."
   SAY "SORRY BUT THERE IS NO DATA TO ANALYSE"
END IF

CALL Waiter
RETURN

DumpIt:
SAY "DUMPING"
DisplayControl% = 0
FOR I% = 0 TO ArraySize%
    PRINT I%, ta$(I%, 0), ta$(I%, 1)        '<--------------------------
    DisplayControl% = DisplayControl% + 1
    IF DisplayControl% > ScreenLimit% THEN
       CALL Waiter
       DisplayControl% = 0
    END IF
NEXT I%

CALL Waiter
RETURN



'******************v********error handler*****v**********************
ErrorHandler:


PRINT "ErrorHandler Says...."











IF ERR = 53 OR ERR = 76 OR ERR = 68 OR ERR = 52 OR ERR = 64 OR ERR = 75 THEN
   PRINT "A file you wanted to process, "; FileName$
   SAY "FILE ERROR"
   PRINT "Could not be found/created."
   Found = False
   CALL Waiter
   RESUME NEXT
END IF

IF ERR = 61 THEN
   PRINT "Sorry, the disk is full."
   SAY "SORRY DISK IS FULL"
ELSE
   
   PRINT "You had an Error #"; ERR
   SAY "THERE WAS AN ERROR"

END IF

PRINT "Press any key to quit...."
SAY "GOOD BYE"


K$ = ""
DO WHILE K$ = ""
   K$ = INKEY$
LOOP
RESUME ExitRoutine
'********************^*******error handler******^**********************
'**********************************************************************
'****************V************helper***********V**********************
Help:
SAY "JUST CHAT WITH ME OR TYPE STOP THEN EXIT TO END"
'Display a primitive help screen
CLS
'PRINT "Doofus Phone Book System"
PRINT
PRINT
PRINT "Name/Help/Dump/Sort/Load/Save/Analyse/Stop? HELP"
PRINT
'PRINT "The Doofus Phone Book System was written as a demonstration of Hashed"
'PRINT "Data Access, rather than as a phone book system.  If it works for you,"
'PRINT "fine, but that was not the author's intent."
PRINT
PRINT "At the first prompt "; CHR$(34); "Name/Help/Dump/Sort/Load/Save/Analyse:"; CHR$(34); ","
PRINT "You may enter a name to be added or looked up in the data base by entering"
PRINT "the name."
PRINT "You may ask for help by entering "; CHR$(34); "HELP"; CHR$(34); "."
PRINT "You may see a raw dump of the data array by entering "; CHR$(34); "DUMP"; CHR$(34); "."
PRINT "You may see a sorted data dump of the array by entering "; CHR$(34); "SORT"; CHR$(34); "."
PRINT "You may load or save the data to/from disk with the LOAD and SAVE commands."
PRINT "You may analyse the data set by entering the command "; CHR$(34); "ANALYSE"; CHR$(34); "."
PRINT "You may exit the application by entering the command "; CHR$(34); "STOP"; CHR$(34); "."
CALL Waiter
CLS
'PRINT "Doofus Phone Book System"
PRINT
PRINT
PRINT "Name/Help/Dump/Sort/Load/Save/Analyse/Stop? HELP"
PRINT
PRINT "Once you have called up a phone number entry, you may continue by pressing"
PRINT CHR$(34); "ENTER"; CHR$(34); ", or you may change the data by entering a "; CHR$(34); "C"; CHR$(34); ","
PRINT "or you may delete the data by pressing a "; CHR$(34); "D"; CHR$(34); "."
CALL Waiter
CLS
RETURN
'********************^*******error handler******^**********************


'********************^*******LOADER******^**********************
LoadIt:
'load the data from a data file

Free% = 0
Empty% = Empty% + 1

FOR I% = 0 TO ArraySize%
    IF ta$(I%, 0) = "" THEN '<------------------
       Free% = Free% + 1
       Empty% = Empty% + 1
  
    ELSEIF ta$(I%, 0) = DeletedValue$ THEN  '<--------------------------
       Free% = Free% + 1
    END IF
NEXT I%

IF Empty% = 0 THEN
   GOSUB SorryFull

ELSE
   INPUT "Name of file to load:"; nm$
   FileName$ = "c:\compiler\" + nm$ + ".dat"
   ON ERROR GOTO ErrorHandler
   Found = True
   OPEN FileName$ FOR INPUT AS 1

   IF Found = True THEN
      DO WHILE NOT EOF(1) AND Free% > 0
         INPUT #1, TestName$, PhoneNumber$
         CALL GetData(TestName$, Index%, Seeks%, SaveIndex%)

         IF SeekCount% >= RetryLimit% THEN
            PRINT "The data base is full and/or needs to be resized"
            YesOrNo$ = ""
            DO WHILE YesOrNo$ <> "Y" AND YesOrNo$ <> "N"
               INPUT "Do you want to see a data base dump (Y/N)"; YesOrNo$
               IF YesOrNo$ <> "" THEN
                  YesOrNo$ = WhackIt$(YesOrNo$)
               END IF
               IF YesOrNo$ = "Y" THEN
                  GOSUB DumpIt
               ELSEIF YesOrNo$ <> "N" THEN
                  PRINT "Please Enter A Y for Yes or a N for NO."
               END IF
            LOOP

            Free% = 0 'force a shutdown
            CALL Waiter
          'im changeing A$ to ta$ below
         ELSEIF ta$(Index%, 0) = TestName$ THEN     '<--------------------------
            ' the value is already on file
            ' we'll just replace the old value for now,
            ' and keep on truckin - we could ask the user
            ' what we should do, but not for a test program!
            ta$(Index%, 1) = PhoneNumber$              '<--------------------------
            PRINT ta$(Index%, 0); "has been updated!"  '<--------------------------

         ELSE
            IF SaveIndex% <> -1 THEN
               'reuse deleted space
               Index% = SaveIndex%
               PRINT "We are reclaiming unused space!  Ain't it great!"
            END IF
            ta$(Index%, 0) = TestName$       '<--------------------------
            ta$(Index%, 1) = PhoneNumber$    '<--------------------------
            Free% = Free% - 1
         END IF

         IF Free% < 1 THEN
            PRINT "The data base has been completely filled."
            PRINT "Some data was not loaded from the file you selected."
            PRINT
            GOSUB SorryFull

            CALL Waiter
         END IF
      LOOP
      CLOSE 1
   END IF
   ON ERROR GOTO 0
END IF

RETURN

SaveIt:
'Save data to a selected file

ON ERROR GOTO ErrorHandler

INPUT "Name of file to save data to:"; nm$
FileName$ = "c:\compiler\" + nm$ + ".dat"
SAY "SAVEING DATA"
OPEN FileName$ FOR OUTPUT AS 1
FOR I% = 0 TO ArraySize%
    IF ta$(I%, 0) <> "" AND ta$(I%, 0) <> DeletedValue THEN        '<--------------------------
       PRINT #1, ta$(I%, 0); ","; ta$(I%, 1)                       '<--------------------------
    END IF
NEXT I%
CLOSE 1
RETURN

SortIt:
 SAY "SORTING DATA"
' convert, sort, and dump the data base

'convert the hashed A$() into a packed SortSpace$()

PRINT "Converting the data into a linear array...."
NextEntry% = 0
FOR I% = 0 TO ArraySize%
    IF ta$(I%, 0) <> "" AND ta$(I%, 0) <> DeletedValue$ THEN '<--------------------
       SortSpace$(NextEntry%, 0) = ta$(I%, 0)                    '<--------------------------
       SortSpace$(NextEntry%, 1) = STR$(I%)
       'track the location of the data, not the data....
       NextEntry% = NextEntry% + 1
    END IF
NEXT I%

IF NextEntry% <= 0 THEN
   PRINT "No Data Was Found To Display."
 
ELSE
'now that all the data has been moved from A$() to SortSpace$(), we
'need to sort it.  How about an exchange sort?
   LastItem% = NextEntry% - 1
   IF LastItem% > 1 THEN
      PRINT "Sorting"; LastItem% + 1; "items.  Please Wait....."
      FOR I% = 0 TO LastItem% - 1
          Lowest% = I%
          FOR J% = I% + 1 TO LastItem%
              CompareCount! = CompareCount! + 1
              IF SortSpace$(J%, 0) < SortSpace$(Lowest%, 0) THEN
                 Lowest% = J%
              END IF
          NEXT J%
          IF Lowest% <> I% THEN
             SWAP SortSpace$(I%, 0), SortSpace$(Lowest%, 0)
             SWAP SortSpace$(I%, 1), SortSpace$(Lowest%, 1)
          END IF
      NEXT I%
   ELSE
      PRINT "1 item found, the sort will be skipped this time...."
      SAY "ONE ITEM FOUND THE SORT WILL BE SKIPPED THIS TIME"
   END IF

   'Now the keys are sorted, so let's display the data....
   PRINT "Order", "Input", "Response", "Place in ta$"'<-------------------
  
   DisplayCount% = 0
   FOR I% = 0 TO LastItem%
       Pointer% = VAL(SortSpace$(I%, 1))
       PRINT I%, ta$(Pointer%, 0), ta$(Pointer%, 1), Pointer%     '<--------------------------
       DisplayCount% = DisplayCount% + 1
       IF DisplayCount% > ScreenLimit% THEN
          CALL Waiter
          DisplayCount% = 0
       END IF
   NEXT I%
END IF
CALL Waiter
RETURN

SorryFull:
PRINT "Sorry, but there is no space available in the array."
PRINT "Try saving your data, stopping this program, resizing"; CHR$(34); "ArraySize%"; CHR$(34); ","
PRINT "reloading the saved data, and then retry this load."
RETURN


'**********************endPHBOOK****************************************************














'*****************

'************

'****************************end of new code****************************************

NUMDATA:
DATA "ONE","TWO","THREE","FOUR","FIVE","SIX","SEVEN","EIGHT","NINE","TEN","ELEVEN","TWELVE"
DATA "THIRTEEN","FOURTEEN","FIFTEEN","SIXTEEN","SEVENTEEN","EIGHTEEN","NINETEEN"
DATA "TEN","TWENTY","THIRTY","FORTY","FIFTY","SIXTY","SEVENTY","EIGHTY","NINETY"
DEFINT A-Z
DEFSNG A-Z

FUNCTION Capital (L$)

IF L$ = UCASE$(L$) THEN Capital = 1 ELSE Capital = 0
END FUNCTION

SUB delay (tdelay!)
'talkhead
END SUB

DEFINT A-Z
'------------------------------------------------------------------------------
FUNCTION GetBlasterAddr%
'Get Blaster Address and DMA channel from Environment Variable
tmp% = 0  'No Environment Variable Set...default
blast$ = UCASE$(ENVIRON$("BLASTER"))
IF LEN(blast$) THEN
   tmp% = INSTR(blast$, "A")
   tmp1$ = MID$(blast$, tmp% + 1, 3)
   tmp% = VAL("&H" + tmp1$)
   IF tmp% = 203 THEN tmp% = -1    'If there is no value assigned
   IF tmp% > 0 THEN
      tmp2% = INSTR(blast$, "D")
      dma% = VAL(MID$(blast$, tmp2% + 1))        'dma% is a global variable
      IF dma% < 0 OR dma% > 7 THEN tmp% = -2
   END IF
END IF
GetBlasterAddr% = tmp%
END FUNCTION

DEFSNG A-Z
SUB GetData (Key$, Index%, SeekCount%, SaveIndex%)

' Try to get the index to the record that that contains Key$ as it's key
' Key$ - the value are looking for
' Found% - did we find Key$ - True/False returned
' Index% - a pointer to where Key$ was found
' SeekCount% - how many tries it took us to fing Key$
' SaveIndex% - the pointer to the first deleted value we found, if any

Index% = Hash(Key$) 'start the search
SaveIndex% = -1
SeekCount% = 1

IF ta$(Index%, 0) <> "" AND ta$(Index%, 0) <> Key$ THEN '<--------------------------
   'if data in entry, and not a match, do a retry
   ReHashCount% = 0

   DO WHILE SeekCount% < RetryLimit% AND ta$(Index%, 0) <> "" AND ta$(Index%, 0) <> Key$'<------------         '<--------------------------
      IF ta$(Index%, 0) = DeletedValue$ AND SaveIndex% = -1 THEN  '<--------------
        'if this is the first deleted value, save it for data insertion
        SaveIndex% = Index%
      END IF

      Index% = Index% + PowersOfTwo%(ReHashCount%)
      DO WHILE Index% > ArraySize%
         Index% = Index% - ArraySize%
      LOOP
          
      ReHashCount% = ReHashCount% + 1
      IF ReHashCount% > PowerMax% THEN
         ReHashCount% = 0
      END IF

      SeekCount% = SeekCount% + 1
          
   LOOP
END IF

END SUB

SUB GuessWord (WS$)
'Guess word routines worked badly, so I added the New Word sub.
NewWord WS$
END SUB

FUNCTION Hash (TestString$)
' turn TestString into a number in the range of 0 - ArraySize%
' the function can be tailored to suit the users needs

Trial = 0

FOR I% = 1 TO LEN(TestString$)
    Trial = Trial + ASC(MID$(TestString$, I%, 1))
NEXT I%

Hash = (Trial * Trial) MOD ArraySize%



END FUNCTION

DEFINT A-Z
SUB NewWord (W$)
SCREEN 12
REENTER:
CLS
PRINT "*** UNKNOWN WORD ***"
PRINT "Input a list of sound codes for the word ''"; UCASE$(W$); "''."
PRINT "The sound codes are:"
PRINT "A  as in bAnanA:    a", , "A  as in mAp:       A"
PRINT "A  as in bOther:    1", , "Ay as in dAY:       2"
PRINT "A  as in bAd:       3", , "Aw as in nOW:       4"
PRINT "Aw as in sAW:       5", , "B  as in BaBy:      b"
PRINT "Ch as in CHin:      c", , "D  as in unDone:    d"
PRINT "E  as in bEt:       e", , "Ea as in bEAt:      E"
PRINT "F  as in FiFty:     f", , "G  as in Go:        g"
PRINT "G  as in Gem:       G", , "H  as in Hat:       h"
PRINT "I  as in tIp:       i", , "I  as in bUY:       I"
PRINT "Ir as in bIRd:      j", , "K  as in CooK:      k"
PRINT "L  as in pooL:      l", , "M  as in diM:       m"
PRINT "N  as in No:        n", , "Ng as in siNG:      N"
PRINT "O  as in bOne:      o", , "Oi as in cOIn:      O"
PRINT "O  as in jOb:       6", , "Oo as in wOOd:      7"
PRINT "P  as in PePPer:    p", , "R  as in RaRe:      r"
PRINT "S  as in leSS:      s", , "Sh as in SHy:       S"
PRINT "T  as in aTTack:    t", , "Th as in THen:      T"
PRINT "Th as in THirteen:  H", , "U  as in rUle:      u"
PRINT "U  as in hUmdrUm:   U", , "U  as in Union:     8"
PRINT "U  as in cUrable:   9", , "V  as in giVe:      v"
PRINT "W  as in We:        w", , "W  as in ONe:       W"
PRINT "Z  as in raISE:     z", , "Pause (about 25ms): 0"
INPUT "Sound codes? ", SC$
FOR b = 1 TO LEN(SC$)
S$ = MID$(SC$, b, 1)
IF S$ = " " THEN EXIT SUB
IF Capital(S$) THEN PlayWav "c" + S$ + ".wav" ELSE PlayWav S$ + ".wav":
NEXT b
PRINT "was this correct ''"; W$; "''?  (Y/N)";
INPUT YN$

IF UCASE$(YN$) = "N" THEN GOTO REENTER
IF UCASE$(YN$) = "Y" THEN


PRINT "Teaching the program a new word..."
FFF = FREEFILE
OPEN "c:\compiler\AIspeech\Words.dat" FOR APPEND AS FFF
PRINT #FFF, W$
PRINT #FFF, SC$
CLOSE
SLEEP 1
PRINT "Re-loading word list..."
OPEN "c:\compiler\AIspeech\Words.dat" FOR INPUT AS #1

DO UNTIL EOF(1)
A% = A% + 1
INPUT #1, aa$
INPUT #1, bb$
Words(A%).WORD$ = LTRIM$(RTRIM$(UCASE$(aa$)))
bb$ = LTRIM$(RTRIM$(bb$))
sr$ = ""
S$ = ""
Words(A%).SND$ = bb$
LOOP
CLOSE #1
Words(A% + 1).SND$ = "END OF LIST"
Words(A% + 1).WORD$ = "END OF LIST"
END IF
PRINT "ADDING TO FILE DONE!"

END SUB

FUNCTION NUMWORD$ (N%)
'REM -- Subroutine to convert amt to alpha
t3 = N%
'REM UP TO $ 999,999.99
TH = 0: HU = 0: TE = 0: UN = 0: AMT$ = ""
IF t3 >= 1000! THEN TH = FIX(t3 / 1000)
IF t3 >= 100! THEN HU = FIX((t3 - (TH * 1000)) / 100)
IF t3 >= 10! THEN TE = FIX((t3 - ((TH * 1000) + (HU * 100))) / 10)
IF t3 >= 1! THEN UN = FIX(t3 - ((TH * 1000) + (HU * 100) + (TE * 10)))
IF TE = 1! THEN TE = UN + 10: UN = 0
TEST = t3 - FIX(t3)
test2 = CINT(TEST * 100)
CTS$ = STR$(test2)
CTS = VAL(RIGHT$("00" + LTRIM$(CTS$), 2))
REM -- Thousands
XCOUNT = 0: SAVE.TH = 0
IF TH = 0! THEN GOTO 2360
IF TH > 19! THEN
SAVE.TH = TH
IF TH < 30 AND TH > 20 THEN AMT$ = "Twenty " + A1$(TH - 20) + " THOUSAND": GOTO 2360
IF TH = 20 THEN AMT$ = "TWENTY THOUSAND": GOTO 2360
XCOUNT = 2: SAVE.TH = SAVE.TH - 20
WHILE SAVE.TH > 0
SAVE.TH = SAVE.TH - 10: XCOUNT = XCOUNT + 1
WEND
SAVE.TH = SAVE.TH + 10: XCOUNT = XCOUNT - 1
IF XCOUNT > 9 THEN
XCOUNT = XCOUNT - 9
IF TH > 100 THEN XCOUNT = FIX(TH / 100): SAVE.TH = TH - (100 * XCOUNT)
IF TH > 100 AND SAVE.TH > 19 THEN
AMT$ = A1$(XCOUNT) + " HUNDRED " + A2$(FIX(SAVE.TH / 10)) + " " + A1$(SAVE.TH - (FIX(SAVE.TH / 10) * 10)) + " THOUSAND": GOTO 2360
END IF
AMT$ = A1$(XCOUNT) + " HUNDRED " + A1$(SAVE.TH) + " THOUSAND": GOTO 2360
ELSE
AMT$ = A2$(XCOUNT)
IF SAVE.TH > 0 THEN AMT$ = AMT$ + " " + A1$(SAVE.TH)
AMT$ = AMT$ + " THOUSAND": GOTO 2360
END IF
END IF
IF TH <= 19 THEN AMT$ = A1$(TH) + " THOUSAND"
2360 REM -- Hundreds
IF HU = 0! THEN GOTO 2400
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
AMT$ = AMT$ + A1$(HU) + " HUNDRED"
2400 REM -- Tens
IF TE = 0! THEN GOTO 2450
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
IF TE > 9! THEN AMT$ = AMT$ + A1$(TE): GOTO 2450
AMT$ = AMT$ + A2$(TE)
2450 REM -- Units
IF UN = 0! THEN NUMWORD$ = AMT$: EXIT FUNCTION
IF AMT$ <> "" THEN AMT$ = AMT$ + " "
AMT$ = AMT$ + A1$(UN)
IF t3 > 0 AND t3 < 1 THEN AMT$ = "NONE"
NUMWORD$ = AMT$
END FUNCTION

'------------------------------------------------------------------------------
SUB PlayBack (BUFFER$, Size%, FREQ&, BytesPerSec&, chans%, Num%)
FREQ& = FREQ& + 1650
Size% = Size% - 1
segment& = VARSEG(BUFFER$)
offset& = SADD(BUFFER$)
IF segment& < 0 THEN segment& = segment& + 65536
IF offset& < 0 THEN offset& = offset& + 65536
baseaddr& = segment& * 16 + offset&
look1% = VARPTR(baseaddr&)
look2% = VARPTR(Size%)
SELECT CASE dma%
   CASE 0
      dmapage% = &H87   '135 decimal
      dmaaddr% = 0
      dmalen% = 1
   CASE 1
      dmapage% = &H83   '131 decimal
      dmaaddr% = 2
      dmalen% = 3
   CASE 2
      dmapage% = &H81
      dmaaddr% = 4
      dmalen% = 5
   CASE 3
      dmapage% = &H82
      dmaaddr% = 6
      dmalen% = 7
   CASE 4
      dmapage% = &H8F
      dmaaddr% = &HC0
      dmalen% = &HC2
   CASE 5
      dmapage% = &H8B
      dmaaddr% = &HC4
      dmalen% = &HC6
   CASE 6
      dmapage% = &H89
      dmaaddr% = &HC8
      dmalen% = &HCA
   CASE 7
      dmapage% = &H8A
      dmaaddr% = &HCC
      dmalen% = &HCE
END SELECT
SELECT CASE dma%
   CASE 0 TO 3
      dmamask% = &HA
      dmamode% = &HB
      dmaclear% = &HC
      dmastatus% = &H8
   CASE 4 TO 7
      dmamask% = &HD4
      dmamode% = &HD6
      dmaclear% = &HD8
      dmastatus% = &HD0
END SELECT
SELECT CASE dma%
   CASE 0, 4
      dmaterminal% = 1   'bit 0 of status register (&H08 or &HD0)
   CASE 1, 5
      dmaterminal% = 2   'bit 1
   CASE 2, 6
      dmaterminal% = 4   'bit 2
   CASE 3, 7
      dmaterminal% = 8   'bit 3
END SELECT

OUT dmamask%, dma% + 4   'mask the dma channel
OUT dmaclear%, &H0       '(clear the internal DMA flip/flop)
OUT dmamode%, 72 + dma%  '  72=010010XX where XX=dmachannel%
OUT dmaaddr%, PEEK(look1%)      'bits 0-7 of  the 20bit address
OUT dmaaddr%, PEEK(look1% + 1)  'bits 8-15 of the 20bit address
OUT dmapage%, PEEK(look1% + 2)  'bits 16-19 of the 20 bit address
OUT dmalen%, PEEK(look2%)       'bits 0-7 of size%
OUT dmalen%, PEEK(look2% + 1)   'bits 8-15  of size%
OUT dmamask%, dma%              'enable channel

IF Num% = 1 THEN  'only need to Write out time constant once
   timeconst% = 256 - 1000000 / (FREQ& * chans%)
   CALL WriteToDSP(&H40)
   CALL WriteToDSP(timeconst%)
   'Reset Mixer    DSPmixeraddress = Blasteraddr% + &H4
   OUT BlasterAddr% + &H4, &H0
   OUT BlasterAddr% + &H4 + 1, 0
   'Set Volume to Maximum...255
   OUT BlasterAddr% + &H4, &H22
   OUT BlasterAddr% + &H4 + 1, 25
5
   IF chans% = 2 THEN
      'Set mixer to Stereo Output
      OUT BlasterAddr% + &H4, &HE
      OUT BlasterAddr% + &H4 + 1, 34      '34=2^5+2^1
   END IF
END IF
IF BytesPerSec& > 22000 THEN
   CALL WriteToDSP(&H48)   'Set Block Size
ELSE
   CALL WriteToDSP(&H14)   'DMA Mode 8-bit DAC
END IF
CALL WriteToDSP(PEEK(look2%))      'Lo byte of address
CALL WriteToDSP(PEEK(look2% + 1))  'High byte of address
IF BytesPerSec& > 22000 THEN CALL WriteToDSP(&H91)  'High Speed DMA mode 8-bit
dummy% = INP(dmastatus%)    'Read status byte once to make sure DMA is going.
WAIT dmastatus%, dmaterminal%   'Loop until terminal count bit set in DMA status register
'DMA Transfer is Now Complete
'Acknowledge the DSP interrupt by reading the DATA AVAILABLE port once
dummy% = INP(BlasterAddr% + &HE)    'DSP Available address
END SUB

DEFSNG A-Z
SUB PlayWav (WaveFile$)
'IF wavefile$ = "c .wav" THEN EXIT SUB
'PRINT wavefile$
repeats% = 1
'BLASTERADDR% = GetBlasterAddr%
SELECT CASE BlasterAddr%
   CASE -2
      PRINT "Bad DMA Channel specified!"
      END
   CASE -1
      PRINT "No Port Base Address Given!"
      END
   CASE 0
      PRINT "No BLASTER Environment Variable Set!"
   CASE ELSE
      'Assume a valid Address Exists
'      PRINT "Blaster Address = "; HEX$(BlasterAddr%)
END SELECT
IF NOT SBreset% THEN
   PRINT "SoundBlaster Card Would Not Reset!"
END IF
sp% = INSTR(Spec$, " ")
IF sp% THEN
   WaveFile$ = LEFT$(Spec$, sp% - 1)
   repeats% = VAL(RIGHT$(Spec$, LEN(Spec$) - sp%))
   IF repeats% = 0 THEN repeats% = 1
ELSE
   IF LEN(Spec$) THEN
      WaveFile$ = Spec$
      repeats% = 1
   END IF
END IF

IF LEN(WaveFile$) = 0 THEN
END IF
CALL ValidWavHeader(WaveFile$, LenHeader%, WavLen&, Channels%, Sampling&, bytes&, ok%)
IF NOT ok% THEN
   PRINT "Bad Wave File Format"
   PRINT WaveFile$
   PRINT "Probably file not found. Check directory."
   PRINT "Or you need to program this word in. It can't be guessed."
END
END IF
MaxBuffer% = 7053
CALL WriteToDSP(&HD1)  'Speaker ON
FOR repeat% = 1 TO repeats%    'This can loop to play the file ii% times]
filenum% = FREEFILE
   OPEN WaveFile$ FOR BINARY AS filenum%
      Num% = 0
      SEEK filenum%, LenHeader% + 1
      Remaining& = WavLen&
      DO
         Num% = Num% + 1
         IF Remaining& > MaxBuffer% THEN
            BufferLen% = MaxBuffer%
         ELSE
            BufferLen% = Remaining&
         END IF
         Remaining& = Remaining& - BufferLen%
         BUFFER$ = SPACE$(BufferLen%)
         GET filenum%, , BUFFER$
         CALL PlayBack(BUFFER$, BufferLen%, Sampling&, bytes&, Channels%, Num%)
      LOOP WHILE Remaining& > 0
      OUT &H20, &H20   'Reset Normal Interrupt Service
   CLOSE filenum%
NEXT repeat%
CALL WriteToDSP(&HD3)  'Speaker OFF
'SLEEP
END SUB

SUB SAY (e$)
e$ = UCASE$(e$)
REMAIN$ = e$ + " EnDoFwAvEpHrAsE!"
DO UNTIL LTRIM$(RTRIM$(REMAIN$)) = "EnDoFwAvEpHrAsE!"
A = 0
  DO UNTIL t$ = " "
    A = A + 1
    t$ = MID$(REMAIN$, A, 1)
   LOOP
sayword LTRIM$(RTRIM$(LEFT$(REMAIN$, A)))
REMAIN$ = LTRIM$(RTRIM$(RIGHT$(REMAIN$, LEN(REMAIN$) - A + 1))): t$ = "": A = 0
sayword "[LONGPAUSE]"
LOOP
END SUB

SUB sayword (W$)
A = WordArray(UCASE$(W$))
IF A = -1 THEN GuessWord LCASE$(W$): EXIT SUB
FOR b = 1 TO LEN(Words(A).SND$)
S$ = MID$(Words(A).SND$, b, 1)
IF S$ = "" THEN END
IF S$ = " " THEN EXIT SUB
IF Capital(S$) THEN PlayWav "c" + S$ + ".wav" ELSE PlayWav S$ + ".wav"
NEXT b
END SUB

DEFINT A-Z
'------------------------------------------------------------------------------
FUNCTION SBreset%
'DSPreset% = address% + &H6
'DSPread% = address% + &HA
'DSPwrite% = address% + &HC
'DSPavail% = address% + &HE
'DSPmixer% = address% + &H4
OUT BlasterAddr% + &H6, 1   'Reset address
delay .1
OUT BlasterAddr% + &H6, 0
time1! = TIMER: noreset% = 0
DO
   'Read Data Available port until bit 7 is set
   'This should take about 100 micro seconds...give it 1 full second
   IF TIMER - time1! > 1! THEN noreset% = -1
LOOP UNTIL ((INP(BlasterAddr% + &HE) AND 128) = 128) OR noreset%
IF NOT noreset% THEN
   IF INP(BlasterAddr% + &HA) = &HAA THEN
      SBreset% = -1
   ELSE
      SBreset% = 0
   END IF
ELSE
   SBreset% = 0
END IF
END FUNCTION

'------------------------------------------------------------------------------
SUB ValidWavHeader (file$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
rID$ = SPACE$(4)
wID$ = SPACE$(4)
fID$ = SPACE$(4)
dat$ = SPACE$(4)
dummy$ = SPACE$(1)
filenum% = FREEFILE
'
'
'
'File not found? Let me explain...
'
OPEN file$ FOR BINARY AS filenum%
'
'If you are using manual input (typing words directly into the pc),
'then you might have made a typo while entering words. entering a "[",
'or other non-letter character will cause the program to crash becasue
'it cannot find the file "[.wav". Get the idea? Or try to use different
'characters when saying a word. (Only the cahracters listed in the
'beginning of this file are allowed).
'
  GET filenum%, , rID$
  GET filenum%, , rLen&
  GET filenum%, , wID$
  GET filenum%, , fID$
  GET filenum%, , fLen&
  GET filenum%, , wFormatTag%       '2 bytes
  GET filenum%, , nChannels%        '2 bytes
  GET filenum%, , nSamplesPerSec&   '4 bytes
  GET filenum%, , nAvgBytesPerSec&  '4 bytes
  GET filenum%, , nBlockAlign%      '2 bytes
  GET filenum%, , FormatSpecific%   '2 bytes
  'Read bytes until have read fLen& total bytes.
  'I have no idea what these next bytes are used for (if they even exist).
  FOR I% = 1 TO fLen& - 16          '16 bytes is what we have read in so far
     GET filenum%, , dummy$         'read in 1 byte at a time
  NEXT I%
  GET filenum%, , dat$
  IF UCASE$(dat$) = "FACT" THEN
     'funny format...
     GET filenum%, , dummy&
     GET filenum%, , dummy&
     GET filenum%, , dat$
  END IF
  GET filenum%, , dataLen&
  LenHeader% = LOC(1)
CLOSE filenum%
'  CLS
'  PRINT rID$;
'  PRINT rLen&;
'  PRINT wID$;
'  PRINT fID$;
'  PRINT fLen&;
'  PRINT wFormatTag%;       '2 bytes
'  PRINT nChannels%;        '2 bytes
'  PRINT nSamplesPerSec&;   '4 bytes
'  PRINT nAvgBytesPerSec&;  '4 bytes
'  PRINT nBlockAlign%;      '2 bytes
'  PRINT FormatSpecific%;   '2 bytes
'  PRINT dat$;
'  PRINT dataLen&;
'  PRINT LenHeader%
IF UCASE$(rID$) = "RIFF" THEN
   IF UCASE$(wID$) = "WAVE" THEN
      IF UCASE$(dat$) = "DATA" THEN
         IF UCASE$(fID$) = "FMT " THEN
          IF FormatSpecific% = 8 THEN ok% = -1
         END IF
      END IF
   END IF
END IF
END SUB

DEFSNG A-Z
SUB Waiter
' wait for a keypress, then return to caller
PRINT "Press (almost) any key to continue..."
K$ = ""
DO WHILE K$ = ""
   K$ = INKEY$
LOOP

END SUB

FUNCTION WhackIt$ (InputString$)
'whack the input string -
' strip leading and trailing spaces,
' make the remainder upper case, and
' make it a single letter response.
TestString$ = UCASE$(RTRIM$(LTRIM$(InputString$)))
IF LEN(TestString$) > 1 THEN
   TestString$ = LEFT$(TestString$, 1)
END IF
WhackIt$ = TestString$

END FUNCTION

FUNCTION WordArray (WORD$)
Ba = 0
DO
Ba = Ba + 1
WW$ = Words(Ba).WORD$
IF LTRIM$(RTRIM$(WW$)) = LTRIM$(RTRIM$(WORD$)) OR LTRIM$(RTRIM$(WW$)) = "END OF LIST" THEN EXIT DO
LOOP
IF LTRIM$(RTRIM$(WW$)) = "END OF LIST" THEN WordArray = -1 ELSE WordArray = Ba
END FUNCTION

DEFINT A-Z
'------------------------------------------------------------------------------
SUB WriteToDSP (V%)
DO
LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, V%
END SUB

